<template>
    <q-card class="my-card" flat bordered style="max-width: 400px; width: 100%">
        <q-item>
            <q-item-section avatar>
                <q-avatar size="80px">
                    <img :src="worker.image" :alt="Avatar">
                </q-avatar>
            </q-item-section>

            <q-item-section>
                <q-item-label class="text-h6">
                    {{ worker.name }}
                </q-item-label>
                <q-item-label caption>
                    {{ worker.subContractor.name }}
                </q-item-label>
                <q-item-label>
                    <q-btn outline size="sm" color="primary" :to="`/worker/${worker.subContractor.id}/${worker.id}`">
                        View
                        Profile
                    </q-btn>
                </q-item-label>
            </q-item-section>
            <q-item-section top side>
                <q-badge> {{ worker.tag }}</q-badge>
            </q-item-section>
        </q-item>

        <q-separator/>

        <q-card-section>
            <q-list separator>
                <q-item>
                    <q-item-section avatar>
                        <q-icon name="timelapse"/>
                    </q-item-section>
                    <q-item-section>Time Spent in Zone</q-item-section>
                    <q-item-section side> {{ WorkerTimeInfo.duration }}</q-item-section>
                </q-item>
                <q-item>
                    <q-item-section avatar>
                        <q-icon name="history"/>
                    </q-item-section>
                    <q-item-section>Last Seen</q-item-section>
                    <q-item-section side>{{ WorkerTimeInfo.time }}</q-item-section>
                </q-item>
            </q-list>

        </q-card-section>
    </q-card>
</template>

<script lang='ts'>
import {Component, Prop, Vue} from 'vue-property-decorator';
import {WorkerPositionResponse} from "src/classLibrary/APIModels/core/workerPositionResponse";
import {WorkerPrincipalResponse} from "src/classLibrary/APIModels/core/workerPrincipalResponse";
import {GenerateAvatar} from "src/classLibrary/AvatarGenerator";
import {add, formatDistanceStrict, formatRelative} from "date-fns";

@Component
export default class WorkerPositionSummary extends Vue {
    @Prop() position!: WorkerPositionResponse
    @Prop() worker!: WorkerPrincipalResponse


    get WorkerTimeInfo(): { duration: string, time: string } {
        const now = new Date();
        const future = add(now, {seconds: this.position.duration.toFixed(1).ToFloat()})
        const duration = formatDistanceStrict(now, future);
        const time = formatRelative(new Date(this.position.time), now);
        return {duration, time};
    }

    get Avatar() {
        return GenerateAvatar(this.position.name);
    }

}
</script>

<style lang='scss' scoped>

</style>
